/* this file is a part of amp software, (C) tomislav uzelac 1996,1997
*/

/* audio.c  main amp source file 
 *
 * Created by: tomislav uzelac  Apr 1996 
 * Karl Anders Oygard added the IRIX code, 10 Mar 1997.
 * Ilkka Karvinen fixed /dev/dsp initialization, 11 Mar 1997.
 * Lutz Vieweg added the HP/UX code, 14 Mar 1997.
 * Dan Nelson added FreeBSD modifications, 23 Mar 1997.
 */ 

#define AUDIO
#include "audio.h"
#include "getbits.h"
#include "huffman.h"
#include "layer3.h"
#include "proto.h"
#include "minilibc.h"

extern unsigned int audio_time;

int mp3_main()
{
	struct AUDIO_HEADER header;
	int cnt=0,g,min,seg,otim;
	char *p,buf[40]={'-','P','l','a','y','i','n','g',' '};

	DAC_init();

/* initialize globals
*/
	append=data=nch=0;

/* _the_ loop
 */
	for (cnt=0;cnt<BUFFER_SIZE+BUFFER_AUX;cnt++) buffer[cnt]=0;

	for (cnt=0;;cnt++) {
		switch((g=lcd_view_buttons())) {
		case LEFT:
		case DOWN:
		case UP:	return g;
		}
		if (audio_time!=otim) {
			min=audio_time/60;
			seg=audio_time%60;
			p=&buf[9];
			
			*p++='['; p=prtnum(p,min,2);
			*p++=':'; p=prtnum(p,seg,2); *p++=']'; *p++='-';
			*p=0;
			lcd_puts(0,buf);
			otim=audio_time;
		}
		
	 	/* getbits funcs expect first four bytes after BUFFER_SIZE have same contents
		 * as the first four bytes of the buffer. fillbfr() normally takes care of
		 * this when it hits the end of the buffer, but not this first time
		 */
		if (cnt==1) Mmemcpy(&buffer[BUFFER_SIZE],buffer,4); 

		if ((g=gethdr(&header))!=0) return 0;

	/* crc is read just to get out of the way.
	 */
		if (header.protection_bit==0) getcrc();
			
		if (!cnt) {

		int play_sample_rate=t_sampling_frequency[header.ID][header.sampling_frequency];
			DAC_set(play_sample_rate,2);
		}
			
		if (layer3_frame(&header,cnt)) return 0;
	}
}

