#define ERR_SYSERR   -1    /* Generic error from GDROM system       */
#define ERR_DIRERR   -2    /* Root directory not found              */
#define ERR_NOFILE   -3    /* File not found                        */
#define ERR_PARAM    -4    /* Invalid parameters passed to function */
#define ERR_NUMFILES -5    /* Max number of open files exceeded     */
#define ERR_NODISK   -6    /* No disc present                       */
#define ERR_DISKCHG  -7    /* Disc has been replaced with a new one */

/*
 * TOC access macros
*/
/* Split TOC->entry into its components */
#define TOC_LBA(n) ((n)&0x00ffffff)
#define TOC_ADR(n) (((n)&0x0f000000)>>24)
#define TOC_CTRL(n) (((n)&0xf0000000)>>28)
/* Use TOC_TRACK() to convert TOC->first and TOC->last entry to track # */
#define TOC_TRACK(n) (((n)&0x00ff0000)>>16)

typedef struct {
	unsigned int entry[99];
	unsigned int first, last;
	unsigned int leadout;
} TOC;

int gdrom_get_status();
void gdrom_init();
int gdrom_init_drive();
int gdrom_read_sectors(char *buf, int sector, int count);
int gdrom_read_toc(TOC *toc,int session);
