#include "graph.h"
#include "minilibc.h"
#include "proto.h"

extern unsigned char font[];
#define PIXSC	14

void big_puts(int line,char *st)
{
	int i,j,k,x,y,ox,oy,chl,len,r,g,b,col;
	len=strlen(st);
	ox=320-(len*8*PIXSC)/2;
	oy=line*16*PIXSC;
	y=oy;
	for(i=0;i<16;i++) {
		x=ox;
		for(j=0;j<len;j++) {
			chl=font[st[j]*16+i];
			for(k=0;k<8;k++) {
				if (chl&0x80) {
					r=(rand()&63);
					g=(rand()&63);
					b=0x7f;
					col=(r<<16)|(g<<8)|b;
					filled_circle(x+PIXSC/2,y+PIXSC/2,PIXSC/2,col);
				}
				chl<<=1;
				x+=PIXSC;
			}
		}
		y+=PIXSC;
	}
	
}

void pputs(char *st)
{
	while (*st) scr_putch(*st++);
}

void pretty()
{
	int i,j;
	//background
	big_puts(0,"MP3");
	big_puts(1,"Player");
	//LCD rectangle...
	rectangle(0,LCDPOS*16+8,639,(LCDPOS+2*NLINES)*16+8,0xffffff);
	filled_rectangle(1,LCDPOS*16+9,638,(LCDPOS+2*NLINES)*16+7,0x7f+16);
	//Help screen
	fg_color=0xff7f00;	//Orange
	gotoxy(8,3); pputs("SKIP");
	gotoxy(4,6); pputs("STOP");
	gotoxy(8,11); pputs("SKIP");
	fg_color=0x7fff7f;	//Green
	//fg_color=0xffffff;	//White
	gotoxy(8,4); pputs("PREV");
	gotoxy(3,7); pputs("LEAVE");
	gotoxy(8,10); pputs("NEXT");
	gotoxy(13,6); pputs("ENTER");
	gotoxy(13,7); pputs("PLAY");
	
	gotoxy(29,1); pputs("PLAY");
	gotoxy(29,11); pputs("PLAY");
	gotoxy(22,5); pputs("PLAY");
	gotoxy(35,5); pputs("PLAY");
	gotoxy(28,2); pputs("NESTED");
	gotoxy(21,6); pputs("NESTED");
	gotoxy(28,3); pputs("RANDOM");
	gotoxy(34,7); pputs("RANDOM");
	gotoxy(35,6); pputs("DIR");
	gotoxy(29,12); pputs("DIR");
	gotoxy(21,7); pputs("SEQUEN");
	gotoxy(22,8); pputs("TIAL");
	gotoxy(26,13); pputs("SEQUENTIAL");
	
	gotoxy(17,14); pputs("REBOOT");
	fg_color=0xffffff;	//White
	
	//Drawings
	//Controller buttons
	for (i=16;i;i--) {
		j=(16-i)>>2;
		filled_circle(30*16+8+j,5*16+8-j,i,((255-i*8)<<8)); 	//Green
		filled_circle(30*16+8+j,9*16+8-j,i,((255-i*8)<<16));	//Red
		filled_circle(28*16+8+j,7*16+8-j,i,((255-i*8)<<16)|((255-i*8)<<8)); //Yellow
		filled_circle(32*16+8+j,7*16+8-j,i,(255-i*8)); //blue
	}
	wrchar(30,5,'Y');
	wrchar(30,9,'A');
	wrchar(28,7,'X');
	wrchar(32,7,'B');
	
	//Start button
	for (i=0;i<32;i++) {
		hline(20*16-i,20*16+i,15*16+8+i,0x7f7f7f);
	}
	//Cursors
	filled_rectangle(10*16,6*16,11*16,9*16,0x7f7f7f);
	filled_rectangle( 9*16,7*16,12*16,8*16,0x7f7f7f);
	filled_circle(10*16+8,7*16+8,8,0x5f5f5f);
	filled_circle(10*16+8+2,7*16+8-2,3,0x9f9f9f);
	
	//fg_color=0xffffff;
	
}
